#!/usr/bin/perl

# build signed linear tone files

# usage:  tone.pl frequency duration

# where frequency is in hertz and duration is in seconds

# this program produces 8Khz samples 8 bit signed samples as its output

# e.g. to convert an output file from this program via sox:

# to convert from raw to wav:
# tone.pl 512 1 > sample.raw 
# sox -traw -r8000 -s -b sample.raw -t wav sample.wav

$freq = $ARGV[0];

$duration = $ARGV[1];

$loudness = $ARGV[2];

print STDERR "frequency: $freq\n";
print STDERR "duration: $duration seconds\n";
print STDERR "loudness: $loudness\n";

$rate = 8000 ;  # 8000 samples / sec for this s/w

$num_samples = $rate * $duration;


# frequency = cycles / sec, and duration is in seconds -- so the # of
# samples is rate * duration.

# the number of cycles during that time is freq * duration

$PI = 3.14159265;
$TWO_PI = 2.0 * $PI;
$max = 127;

$amplitude = $max * $loudness;

print STDERR "$x, $num_samples\n";


for($x = 0.0 ; $x < $num_samples ; $x++) {
    $place = ($x / $rate * $TWO_PI * $freq);
    $y = sin($place);
    $new_y = int($y * $amplitude + .5);
    print pack ("c", $new_y);
}
